function L=Cho(A)
%give L of Cholesky factorization of A
nn=size(A);
n=nn(1);%get size of A
L=zeros(n);
L(1,1)=sqrt(A(1,1));
for j=2:n
    L(j,1)=A(1,j)/L(1,1);
end
for i=2:n-1
    L(i,i)=sqrt(A(i,i)-norm(L(i,1:i-1))^2);
    for j=i+1:n
        L(j,i)=(A(i,j)-sum(L(i,1:i-1).*L(j,1:i-1)))/L(i,i);
    end
end
L(n,n)=sqrt(A(n,n)-norm(L(n,1:n-1))^2);
end