clear
clc
n=1001;%size of matrix
p=0.1;
A=get_mat_sparse(n,p);%get sparse matrix
x0=rand(n,1);%exact solution
b=A*x0;
XO=zeros(n,1);%initial value
TOL=1e-10;%error tolerance
N=100;%tolerance of number of iterations
%mt and ms is number of iterations of method
%nt and ns is the error of method
mt=zeros(1,2);
ms=zeros(1,19);
[~,mt(1)]=Jac(A,b,XO,TOL,N);
[~,mt(2)]=GS(A,b,XO,TOL,N);
T=10;
d=0.01;%step of omega
%use SOR method with different omega to get solution
for j=1:2*T-1
    XO=zeros(n,1);
    omega=1-T*d+j*d;
    n=length(b);
    k=1;
    s=(1:n);
    x=zeros(n,1);
    while k<=N
        for i=1:n
            indl=(s<i);
            indu=(s>i);
            x(i)=(1-omega)*XO(i)+omega*((-sum(A(i,indl)'...
                .*x(indl))-sum(A(i,indu)'.*XO(indu)))+b(i))/A(i,i);
        end
        if norm(x-XO)<TOL
            m=k;
            break
        end
        k=k+1;
        XO=x;
    end
if k>N
    continue
else
    ms(j)=m;
end
end