function [x,m]=Jac(A,b,XO,TOL,N)
%Jacobi Iterative
%x is the approximate solution
%m is the final number of iterations
n=length(b);
k=1;
s=(1:n);
x=zeros(n,1);
while k<=N
    for i=1:n
        ind=(s~=i);
        x(i)=(-sum(A(i,ind)'.*XO(ind))+b(i))/A(i,i);
    end
    if norm(x-XO)<TOL
        m=k;
        break
    end
    k=k+1;
    XO=x;
end
if k>N
    disp('Maximum number of iterations exceeded')
end
end