function integral = MC1(n)
%本函数使用算法一计算sin(x^2)在0到1上的积分

% 设定 x 的范围和点的数量
xmin = 0;
xmax = 1;
num_points = n;

% 设定 y 的范围
ymin = 0;
ymax = 1;

% 生成随机点
x = rand(1, num_points) * (xmax - xmin) + xmin;
y = rand(1, num_points) * (ymax - ymin) + ymin;

% 计算随机点对应的函数值
z = sin(x.^2);

% 统计图像下方点的个数
num_points_under_curve = sum(y < z);

% 计算积分值
integral = (num_points_under_curve / num_points)...
    * (xmax - xmin) * (ymax - ymin);