%本函数对于一个给定的阻尼系数给出对应装置的平均功率的相反数
function P = Pa1(lmd)
%定义本问中用到的常量
lmd2=167.8395;%垂荡兴波阻尼系数
m0=1165.992;%垂荡附加质量
m1=2433;%振子质量
k=80000;%弹簧刚度
m2=4866;%浮子质量
omg=2.2143;%波浪频率
l0=0.5;%弹簧原长
rou=1025;%海水密度
R=1;%浮子底半径
h1=3;%浮子圆柱部分高度
h2=0.8;%浮子圆锥部分高度
g=9.8;%重力加速度
f=4890;%垂荡激励力振幅
x1_0=-((m1+m2)/rou-pi*R^2*h2/3)/(pi*R^2)+l0-m1*g/k;%初值
x2_0=-((m1+m2)/rou-pi*R^2*h2/3)/(pi*R^2)-h2;%初值

T=200;%给定一段时长
a=[x1_0,x2_0,0,0];%给定初值
%调用ode45函数解方程
[t,y]=ode45(@(t,y)odefun3(t,y,lmd),[T:0.01:2*T],a);
%由于方程的解在一段时间后稳定下来
%可以用[T,2T]时间内的平均功率代表装置的平均功率
%为使用MATLAB中工具箱求解最大值
%这里将将函数定义为目标函数的相反数
P=-lmd*trapz(t,abs(y(:,3)-y(:,4)).^2)/T;
end

