%本函数对于给定的阻尼系数与幂指数
%给出对应装置的平均功率的相反数
function P = Pa2(x)
lmd=x(1);
alpha=x(2);

%定义本问中用到的常量
lmd2=167.8395;%垂荡兴波阻尼系数
m0=1165.992;%垂荡附加质量
m1=2433;%振子质量
k=80000;%弹簧刚度
m2=4866;%浮子质量
omg=2.2143;%波浪频率
l0=0.5;%弹簧原长
rou=1025;%海水密度
R=1;%浮子底半径
h1=3;%浮子圆柱部分高度
h2=0.8;%浮子圆锥部分高度
g=9.8;%重力加速度
f=4890;%垂荡激励力振幅
x1_0=-((m1+m2)/rou-pi*R^2*h2/3)/(pi*R^2)+l0-m1*g/k;%初值
x2_0=-((m1+m2)/rou-pi*R^2*h2/3)/(pi*R^2)-h2;%初值

%以下同Pa1.m中的注释
T=200;
a=[x1_0,x2_0,0,0];
[t,y]=ode45(@(t,y)odefun4(t,y,lmd,alpha),[T:0.01:2*T],a);
P=-lmd.*trapz(t,abs(y(:,3)-y(:,4)).^(alpha+2))/T;
end

