%本函数对于给定的浮子下端高度坐标，返回浮子排开水的体积
function V_a = Va(x)

%定义本问中用到的常量
lmd1=10^4;%阻尼系数
lmd2=656.3616;%垂荡兴波阻尼系数
m0=1335.535;%垂荡附加质量
m1=2433;%振子质量
k=80000;%弹簧刚度
m2=4866;%浮子质量
omg=1.4005;%波浪频率
l0=0.5;%弹簧原长
rou=1025;%海水密度
R=1;%浮子底半径
h1=3;%浮子圆柱部分高度
h2=0.8;%浮子圆锥部分高度
g=9.8;%重力加速度
f=4890;%垂荡激励力振幅
x1_0=-((m1+m2)/rou-pi*R^2*h2/3)/(pi*R^2)+l0-m1*g/k;%初值
x2_0=-((m1+m2)/rou-pi*R^2*h2/3)/(pi*R^2)-h2;%初值

if x>=0%装置整个离开水面时
    V_a=0;
else if x>=-h2 && x<0
%装置有且仅有圆锥部分与水面相接触
        V_a=h2*pi*R^2/3*(-x)^3;
    else if x<-h2 && x>=-(h1+h2)
%装置有且仅有圆柱部分与水面相接触
    V_a=pi*R^2*h2/3+pi*R^2*(-h2-x);
        else%装置完全沉入水中
            V_a=pi*R^2*h2/3+pi*R^2*h1;
        end
    end
end
end

