function hermite=hermite(x,t,f,df)
%x is interpolating nodes,t is variable,
%f is interpolated function,df is derivative of f
n=length(x);
hermite=zeros(1,length(t));
for i=1:n
hermite=hermite+H(i,t,0).*f(x(i))+H(i,t,1).*df(x(i));
end
    function H=H(m,t,a)
        if a==0
            if m==1
                c=(x(1)<=t) & (t<=x(2));
                H(c)=(1+2.*(t(c)-x(1))./(x(2)-x(1)))...
                    .*((t(c)-x(2))./(x(1)-x(2))).^2;
                H(~c)=0;
            else
                if 2<=m && m<=n-1
                    c=(x(m-1)<=t) & (t<=x(m));
                    d=(x(m)<t) & (t<=x(m+1));
                    H=zeros(1,length(t));
                    H(c)=(1+2.*(t(c)-x(m))./(x(m-1)-x(m)))...
                        .*((t(c)-x(m-1))./(x(m)-x(m-1))).^2;
                    H(d)=(1+2.*(t(d)-x(m))./(x(m+1)-x(m)))...
                        .*((t(d)-x(m+1))./(x(m)-x(m+1))).^2;
                else
                    c=(x(n-1)<=t) & (t<=x(n));
                    H=zeros(1,length(t));
                    H(c)=(1+2.*(t(c)-x(n))./(x(n-1)-x(n)))...
                        .*((t(c)-x(n-1))./(x(n)-x(n-1))).^2;
                end
            end
        else
            if m==1
                c=(x(1)<=t) & (t<=x(2));
                H(c)=(t(c)-x(1)).*((t(c)-x(2))./(x(1)-x(2))).^2;
                H(~c)=0;
            else
                if 2<=m && m<=n-1
                    c=(x(m-1)<=t) & (t<=x(m));
                    d=(x(m)<t) & (t<=x(m+1));
                    H=zeros(1,length(t));
                    H(c)=(t(c)-x(m)).*((t(c)-x(m-1))...
                        ./(x(m)-x(m-1))).^2;
                    H(d)=(t(d)-x(m)).*((t(d)-x(m+1))...
                        ./(x(m)-x(m+1))).^2;
                else
                    c=(x(n-1)<=t) & (t<=x(n));
                    H=zeros(1,length(t));
                    H(c)=(t(c)-x(n)).*((t(c)-x(n-1))...
                        ./(x(n)-x(n-1))).^2;
                end
            end
        end
    end
        
    end