function dy1234 = odefun3(t,y,lmd)

%定义本问中用到的常量
lmd2=167.8395;%垂荡兴波阻尼系数
m0=1165.992;%垂荡附加质量
m1=2433;%振子质量
k=80000;%弹簧刚度
m2=4866;%浮子质量
omg=2.2143;%波浪频率
l0=0.5;%弹簧原长
rou=1025;%海水密度
R=1;%浮子底半径
h1=3;%浮子圆柱部分高度
h2=0.8;%浮子圆锥部分高度
g=9.8;%重力加速度
f=4890;%垂荡激励力振幅
x1_0=-((m1+m2)/rou-pi*R^2*h2/3)/(pi*R^2)+l0-m1*g/k;%初值
x2_0=-((m1+m2)/rou-pi*R^2*h2/3)/(pi*R^2)-h2;%初值
%lmd为阻尼系数

%用于使用ode45函数解得x1,x2
%其中y(1)=x1,y(2)=x2,y(3)=x1',y(4)=x2'
%以海平面为0高度面，x1为振子下端高度
%x2为浮子底端高度，竖直向上为正方向
dy1234=[y(3);y(4);(lmd*(y(4)-y(3))-g*m1...
+k*(l0-(y(1)-y(2)-h2)))/m1;(-lmd*(y(4)-y(3))...
-g*m2-k*(l0-(y(1)-y(2)-h2))+f*cos(omg*t)...
+rou*g*Va(y(2))-lmd2*y(4))/(m0+m2)];
end
